#ifndef __ENTITY_H__
#define __ENTITY_H__

#include <map>
#include "bbox.h"
#include "enum.h"
#include "Sprite.h"

using namespace std;


class Entity
{
public:

	Entity(float x, float y, float w = DEF_ENTITY_W, float h = DEF_ENTITY_H);
	virtual ~Entity();

	void getPosition(float& x, float& y) const;
	void setPosition(float  x, float  y);

	BBox& getBBox();

	bool    addSprite(int id, Sprite* sprite);
	Sprite* removeSprite(int id);
	Sprite* getSprite(int id) const;

	int getNumSprites() const;

	virtual void update(double dt);
	virtual void draw(bool drawBBox = false) const;

protected:

	float pos[2];
	BBox  bbox;

private:

	map<int, Sprite*> sprites;
};

#endif // __ENTITY_H__
