#include "spellPoints.h"


SpellPoints::SpellPoints() :
	firePts(MIN_SP_F), waterPts(MIN_SP_W), earthPts(MIN_SP_E), elecPts(MIN_SP_L)
{
}

SpellPoints::SpellPoints(int fp, int wp, int ep, int lp) :
	firePts(fp), waterPts(wp), earthPts(ep), elecPts(lp)
{
}

SpellPoints::~SpellPoints()
{
}

SpellPoints
SpellPoints::operator+(const SpellPoints& sp) const
{
	SpellPoints r;

	r.setFirePts( firePts  + sp.firePts);
	r.setWaterPts(waterPts + sp.waterPts);
	r.setEarthPts(earthPts + sp.earthPts);
	r.setElecPts( elecPts  + sp.elecPts);

	return r;
}

SpellPoints&
SpellPoints::operator+=(const SpellPoints& sp)
{
	*this = *this + sp;

	return *this;
}

int
SpellPoints::getFirePts() const
{
	return firePts;
}

void
SpellPoints::setFirePts(int fp)
{
	firePts = fp;

	if( firePts < MIN_SP_F ) firePts = MIN_SP_F;
	if( firePts > MAX_SP_F ) firePts = MAX_SP_F;
}

int
SpellPoints::incFirePts(int dFP)
{
	firePts += dFP;

	if( firePts < MIN_SP_F ) firePts = MIN_SP_F;
	if( firePts > MAX_SP_F ) firePts = MAX_SP_F;

	return firePts;
}

int
SpellPoints::decFirePts(int dFP)
{
	firePts -= dFP;

	if( firePts < MIN_SP_F ) firePts = MIN_SP_F;
	if( firePts > MAX_SP_F ) firePts = MAX_SP_F;

	return firePts;
}

int
SpellPoints::getWaterPts() const
{
	return waterPts;
}

void
SpellPoints::setWaterPts(int wp)
{
	waterPts = wp;

	if( waterPts < MIN_SP_W ) waterPts = MIN_SP_W;
	if( waterPts > MAX_SP_W ) waterPts = MAX_SP_W;
}

int
SpellPoints::incWaterPts(int dWP)
{
	waterPts += dWP;

	if( waterPts < MIN_SP_W ) waterPts = MIN_SP_W;
	if( waterPts > MAX_SP_W ) waterPts = MAX_SP_W;

	return waterPts;
}

int
SpellPoints::decWaterPts(int dWP)
{
	waterPts -= dWP;

	if( waterPts < MIN_SP_W ) waterPts = MIN_SP_W;
	if( waterPts > MAX_SP_W ) waterPts = MAX_SP_W;

	return waterPts;
}

int
SpellPoints::getEarthPts() const
{
	return earthPts;
}

void
SpellPoints::setEarthPts(int ep)
{
	earthPts = ep;

	if( earthPts < MIN_SP_E ) earthPts = MIN_SP_E;
	if( earthPts > MAX_SP_E ) earthPts = MAX_SP_E;
}

int
SpellPoints::incEarthPts(int dEP)
{
	earthPts += dEP;

	if( earthPts < MIN_SP_E ) earthPts = MIN_SP_E;
	if( earthPts > MAX_SP_E ) earthPts = MAX_SP_E;

	return earthPts;
}

int
SpellPoints::decEarthPts(int dEP)
{
	earthPts -= dEP;

	if( earthPts < MIN_SP_E ) earthPts = MIN_SP_E;
	if( earthPts > MAX_SP_E ) earthPts = MAX_SP_E;

	return earthPts;
}

int
SpellPoints::getElecPts() const
{
	return elecPts;
}

void
SpellPoints::setElecPts(int lp)
{
	elecPts = lp;

	if( elecPts < MIN_SP_L ) elecPts = MIN_SP_L;
	if( elecPts > MAX_SP_L ) elecPts = MAX_SP_L;
}

int
SpellPoints::incElecPts(int dLP)
{
	elecPts += dLP;

	if( elecPts < MIN_SP_L ) elecPts = MIN_SP_L;
	if( elecPts > MAX_SP_L ) elecPts = MAX_SP_L;

	return elecPts;
}

int
SpellPoints::decElecPts(int dLP)
{
	elecPts -= dLP;

	if( elecPts < MIN_SP_L ) elecPts = MIN_SP_L;
	if( elecPts > MAX_SP_L ) elecPts = MAX_SP_L;

	return elecPts;
}
